<script setup lang="ts">
import VoteBox from '@/components/VoteBox.vue'
import { VoteOnChainData, TellingToken } from '@/scripts/types'
import VoteParameters from '@/components/VoteParameters.vue'
import HasVoted from '@/components/HasVoted.vue'
import { reactive, onMounted, computed } from 'vue'
import { useDataStore } from '@/store/data'
import { useRoute } from 'vue-router'
import { generateTellerKeyPair } from '@/scripts/crypto'
import { useAppStore } from '@/store/app'
import API from '@/scripts/api'
import { getTellingTokens } from '@/scripts/blockchain'

const route = useRoute()
const data = useDataStore()
const app = useAppStore()

const state = reactive({
  voteId: null as number | null,
  onChainVote: undefined as VoteOnChainData | undefined,
  tokens: undefined as TellingToken[] | undefined,
  search: ''
})

const vote = computed(() => {
  return data.votes.find(v => v.id === state.voteId)
})

onMounted(() => {
  const voteIdStr = route.params.id as string
  if (voteIdStr === 'none') {
    return
  }
  state.voteId = parseInt(voteIdStr)
  refreshPage()
})

const filteredTokens = computed(() => {
  if (vote.value == null) return 
  return data.tellingTokens[vote.value.id].filter(t => {
    return t.token.display_name.toLowerCase().includes(state.search.toLowerCase().trim()) || t.token.sciper.includes(state.search.trim())
  })
})

async function refreshPage() {
  await data.refreshVotes()

  if (vote.value == null) return

  keysDialog.existingKeys = localStorage.getItem('teller-keys') || ''
  if (keysDialog.existingKeys.length > 0) {
    const [pubkey, key] = keysDialog.existingKeys.trim().split(' // ')
    data.setTellerKeys(pubkey, key)
  }

  if (data.tellerKeys != null) {
    await getTellingTokens(vote.value.id)
  } else {
    keysDialog.setupDisplayed = true
  }
}

const keysDialog = reactive({
  setupDisplayed: false,
  existingDisplayed: false,
  generatedKeys: '',
  loadedKeys: '',
  existingKeys: '',
  loading: false
})

async function generateKeys() {
  const { pubkey, key } = generateTellerKeyPair()
  data.setTellerKeys(pubkey, key)
  keysDialog.generatedKeys = `${pubkey} // ${key}`
  keysDialog.loadedKeys = ''
  keysDialog.loading = true

  localStorage.setItem('teller-keys', keysDialog.generatedKeys)

  API.updateTellerKey(pubkey).then(() => {
    app.notification('success', 'Clé publique générée et envoyée au serveur')
    refreshPage()
  }).finally(() => {
    keysDialog.loading = false
  })
}

function loadKeys() {
  const [pubkey, key] = keysDialog.loadedKeys.trim().split(' // ')
  data.setTellerKeys(pubkey, key)
  keysDialog.generatedKeys = ''
  app.notification('success', 'Clés scrutateurs chargées !')
  keysDialog.setupDisplayed = false
  refreshPage()
}

function clearKeys() {
  keysDialog.loadedKeys = ''
  keysDialog.generatedKeys = ''
  keysDialog.setupDisplayed = true
  keysDialog.existingDisplayed = false
  localStorage.removeItem('teller-keys')
  data.clearTellerKeys()
}

function displayKeysDialog() {
  if (data.tellerKeys == null) {
    keysDialog.setupDisplayed = true
  } else {
    keysDialog.existingDisplayed = true
  }
}
</script>

<template>
  <div v-if="vote">
    <div class="p-4">
      <div class="flex">
        <h1 class="text-3xl">Suivi du vote #{{ vote.id }}</h1>
        <div class="grow"/>
        <v-btn variant="tonal" link to="/votes/none/teller-monitoring" class="mr-4">
          Changer de vote
        </v-btn>
        <v-btn :color="data.tellerKeys == null ? 'error' : 'primary'" variant="tonal" @click="displayKeysDialog">
          Gestion des clés scrutateurs
        </v-btn>
      </div>
      <v-container fluid >
        <v-row>
          <v-col md="5">
            <vote-box :vote="vote" mode="list-item" class="my-2"/>

            <div>
              <vote-parameters :vote="vote" />
            </div>

          </v-col>
          <v-col md="7">
            <div class="flex items-center text-xl">
              <div >
                Derniers bulletins
              </div>
              <v-card-text>
                <div class="flex items-center">
                  <v-text-field
                    density="compact"
                    variant="solo"
                    label="Rechercher"
                    append-inner-icon="mdi-magnify"
                    single-line
                    hide-details
                    v-model="state.search"
                  />
                </div>
              </v-card-text>
            </div>
            <div class="flex flex-col">
              <v-alert v-if="vote.teller_pubkey?.length != null && vote.teller_pubkey !== data.tellerKeys?.pubkey" color="error" variant="tonal" title="Impossible de déchiffrer les bulletins" text="car votre clé de scrutateur ne correspond pas à celle utilisée pour ce vote." />
              <div v-else-if="data.tellingTokens != null && data.tellingTokens[vote.id] != null">
                <has-voted v-for="token in filteredTokens"  v-bind:key="token.token.sciper" :timestamp="token.timestamp" :token="token.token" />
              </div>
              <v-alert v-else text="Pas de bulletin" />
            </div>
          </v-col>
        </v-row>
      </v-container>
    </div>

    <v-dialog v-model="keysDialog.setupDisplayed" max-width="800px">
      <v-card>
        <v-card-title>
          <span class="text-h5">Gestion des clés des scrutateurs</span>
        </v-card-title>

        <v-card-text>
          <div class="flex divide-x-2">
            <div class="grow flex flex-col justify-center items-center pr-5">
              <h3 class="text-lg text-center">Génération d'un jeton</h3>
              <v-textarea readonly class="w-full mb-4" placeholder="Copier ce jeton et envoyez-le aux autres"
                hide-details :disabled="keysDialog.generatedKeys.length === 0" v-model="keysDialog.generatedKeys" variant="filled"/>
              <v-btn variant="tonal" color="success" @click="generateKeys" :loading="keysDialog.loading">Générer une paire de clé</v-btn>
            </div>
            <div class="grow flex flex-col items-center pl-5">
              <h3 class="text-lg text-center">Chargement d'un jeton</h3>
              <v-textarea class="w-full mb-4" placeholder="Collez ici le jeton d'un autre scrutateur" hide-details v-model="keysDialog
              .loadedKeys"/>
              <v-btn variant="tonal" color="success" @click="loadKeys" :disabled="keysDialog.loadedKeys.length === 0">Charger une paire de clé</v-btn>
            </div>
          </div>
        </v-card-text>

        <v-card-actions>
          <p class="ml-4 text-grey text-xs"><em>NB: ne communiquez pas ces jetons à une personne qui ne fait pas partie des scrutateurs.</em></p>
          <div class="grow"/>
          <v-btn color="" variant="text" @click="keysDialog.setupDisplayed = false" class="mx-4">
            Fermer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog v-model="keysDialog.existingDisplayed" max-width="800px">
      <v-card>
        <v-card-title>
          <span class="text-h5">Gestion des clés des scrutateurs</span>
        </v-card-title>

        <v-card-text>
          <div class="">
            <div>
              <p class="mb-3">Une paire de clés est déjà chargée sur cet appareil. Vous pouvez la supprimer pour en changer ou la partager aux autres scrutateurs.</p>
              <v-textarea readonly class="w-full mb-4" placeholder="Copier ce jeton et envoyez-le aux autres"
                hide-details v-model="keysDialog.existingKeys" variant="filled"/>
                <p class="ml-4 text-grey text-xs"><em>NB: ne communiquez pas ces jetons à une personne qui ne fait pas partie des scrutateurs.</em></p>
            </div>
          </div>
        </v-card-text>

        <v-card-actions>
          <v-btn variant="tonal" color="success" @click="clearKeys">Supprimer cette paire</v-btn>
          <div class="grow"/>
          <v-btn color="" variant="text" @click="keysDialog.existingDisplayed = false" class="mx-4">
            Fermer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>
